
from globalvars import OSTREAM
from instructions import Instruction


class Block:
	instructions = None
	successors = None
	predecesssors = None
	minLocalVarOffset = 0
	maxParamOffset= 0
	maxParamOffset_g= 0
	inMainFunc = False

	def __init__(self):
		self.instructions = []
		self.successors = []
		self.predecessors= []
		self.globalVarSet= set()
		self.minLocalVarOffset = 0
		self.maxParamOffset= 0
		self.maxParamOffset_g= 0
		self.inMainFunc = False
	
	def setInMain(self):
		self.inMainFunc = True

	def set_maxParamOffset_global(self, gMax):
		self.maxParamOffset_g = gMax
	def print3addr(self):
		#OSTREAM.write('printing block...\n')
		for i in self.instructions:
			i.print3addr()

	def printReg(self):
		#OSTREAM.write('printing block...\n')
		for i in self.instructions:
			i.printReg()
		
	def collectGlobalVarSet(self):
		for i in self.instructions:
			self.globalVarSet = self.globalVarSet | i.globalVarSet
			if self.minLocalVarOffset > i.minLocalVarOffset:
				self.minLocalVarOffset = i.minLocalVarOffset
			if self.maxParamOffset< i.maxParamOffset:
				self.maxParamOffset= i.maxParamOffset
		
	def printPPC(self):
		#OSTREAM.write('*     begin block\n')
		for i in self.instructions:
			if self.inMainFunc:
				i.setInMain()
			i.set_maxParamOffset_global(self.maxParamOffset_g)

			i.printPPC()
		#OSTREAM.write('*     end block\n')
