
import re

class Operand:
	source = None

	isBase = None
	base = None
	isOffset = None
	offset = None
	isVar = None
	var = None

	isTemp = None
	temp = None
	isTarget = None
	target = None
	isConstant = None
	constant = None
	isReg = None
	reg = None
	isCreg = None
	creg = None

	isPointer = None
	Pointer = None
	
	ppcReg = None
	isPPCREG = False
	
	isParam = False

	def __init__(self, src):
		self.source = src

		self.isBase = False
		self.base = ''
		self.isOffset = False
		self.offset = ''
		self.isVar = False
		self.var = ''

		self.isTemp = False
		self.temp = ''
		self.isTarget = False
		self.target = ''
		self.isConstant = False
		self.constant = ''
		self.isReg = False
		self.reg = ''
		self.isCreg = False
		self.creg = ''
		
		self.ppcReg = '';
		self.isPPCREG = False
		
		self.isParam = False
		if self.source.count('~')>0 :
			self.isPPCREG = True

		match_base = re.match(r'(\w+_base)#([-\d]+)', self.source)
		match_offset = re.match(r'(\w+_offset)#([-\d]+)', self.source)
		match_var = re.match(r'(\w+)#([-\d]+)', self.source)

		match_temp = re.match(r'(\(\d+\))', self.source)
		match_target = re.match(r'(\[\d+\])', self.source)
		match_constant = re.match(r'(\d+)', self.source)
		match_creg = re.match(r'(cr\d+)', self.source)
		match_reg = re.match(r'(r\d+)', self.source)
		match_pointer = re.match(r'(\w+)', self.source)
		
#		self.ppcReg =self.source
		
		if match_base is not None:
			self.isBase = True
		elif match_offset is not None:
			self.isOffset = True
		elif match_var is not None:
			self.isVar = True
			self.var = match_var.group(1)
			#self.ppcReg = src.split('~')[0]
			self.ppcReg = src.split('#')[1]
			if int(self.ppcReg >0):
				self.isParam = True
		elif match_temp is not None:
			self.isTemp = True
			self.temp = self.source.strip('()')
			self.ppcReg = src.split('~')[0]
		elif match_target is not None:
			self.isTarget = True
			self.ppcReg = self.source.strip('()')
		elif match_constant is not None:
			self.isConstant = True
			self.ppcReg = src.split('~')[0]
		elif match_creg is not None:
			self.isCreg = True
		elif match_reg is not None:
			self.isReg = True
			self.ppcReg = src.split('~')[0]
		elif match_pointer is not None:
			self.isPointer = True
		else:
			print self.source
			assert False ,'unknown operand type'
	
	def toString(self):
		return self.source
	
	def toPPC(self, globalMaxParam, localVarSize):
		if self.ppcReg is not None:
			if self.isTarget:
				num = self.source.strip('[]')
				return 'label_' + num
			if self.isVar:
			    if int(self.ppcReg) < 0 :
			    	return str(56+ localVarSize + int(self.ppcReg))
			    else:
			    	return str(52 - globalMaxParam + int(self.ppcReg))
			if self.isReg:
				return str(int(self.ppcReg.strip('r')))
		else:
			return self.ppcReg.strip('r')
		
		if self.source.startswith('['):
			num = self.source.strip('[]')
			return 'label_' + num
		elif len(self.source.split('#')) > 1:
			return self.source.split('#')[1]
		elif self.source.startswith('r'):
			return self.source.strip('r')
		elif self.source.startswith('cr'):
			return self.source.strip('cr')
		elif self.source == 'FP':
			return '1'
		else:
			return self.source

	def toReg(self):
		if self.isTarget:
			num = self.source.strip('[]')
			return 'label_' + num
		else:
			return self.source

	def isLocal(self):
		result = False
		if len(self.source.split('#')) > 1 and not self.isBase and not self.isOffset:
			num = int(self.source.split('#')[1])
			if num < 0:
				#print self.source
				result = True
		return result

	def isParam(self):
		result = False
		if len(self.source.split('#')) > 1 and not self.isBase and not self.isOffset:
			num = int(self.source.split('#')[1])
			if num > 0:
				#print self.source
				result = True
		return result
