from globalvars import ISTREAM, OSTREAM

class Program:
	functions = None

	def __init__(self):
		self.functions = []
		self.globalVarSet= set()
	
	def print3addr(self):
		for f in self.functions:
			f.print3addr()
	
	def printReg(self):
		for f in self.functions:
			f.printReg()

	def collectGlobalVarSet(self):
		for f in self.functions:
			f.collectGlobalVarSet()
			self.globalVarSet = self.globalVarSet | f.globalVarSet
			
	def printPPC(self):
		#OSTREAM.write('* begin  PROGRAM.\n')
		OSTREAM.write('\t.globl GP\n')
		OSTREAM.write('\t.section\t.sdata,"aw",@progbits\n')
		OSTREAM.write('\t.align 2\n')
		OSTREAM.write('\t.type\tGP, @object\n')
		OSTREAM.write('\t.size\tGP, 4\n')
		OSTREAM.write('GP:\t.long 32768\n')
		OSTREAM.write('\t.section\t".text"\n')


		OSTREAM.write('.LC0:                             \t\n')
		OSTREAM.write('\t.string "%d \\n"             \t\n')
		OSTREAM.write('\t.section        ".text"  \t\n')
		
		for g in self.globalVarSet:
			s  = '.comm  '
			s += g
			s += ',4,4'
			OSTREAM.write("%s\n" % s)
		#OSTREAM.write('.comm   a,4,4')
#		OSTREAM.write('\t.align 2                 \t\n')
#		OSTREAM.write('\t.globl main              \t\n')
#		OSTREAM.write('\t.type   main, @function  \t\n')
				
		
		for f in self.functions:
			f.printPPC()
		#OSTREAM.write('* end    PROGRAM.\n')

	def buildBlocks(self):
		for f in self.functions:
			f.buildBlocks()
	
	def buildCFG(self):
		for f in self.functions:
			f.buildCFG()

	def ssa(self):
		for f in self.functions:
			f.ssa()
	
	def allocRegs(self):
		for f in self.functions:
			f.allocRegs()
